package ru.loparev.session1

import android.graphics.Color
import android.view.LayoutInflater
import android.view.TextureView
import android.view.View
import android.view.ViewGroup
import android.widget.TextView
import androidx.recyclerview.widget.RecyclerView
import kotlinx.android.synthetic.main.bankomat_list.view.*
import ru.loparev.session1.models.Bankomat
import java.text.SimpleDateFormat
import java.util.*

class BankomatAdapter(private val bankomatList:List<Bankomat>):RecyclerView.Adapter<BankomatAdapter.BankomatViewHolder>() {
    class BankomatViewHolder(itemView:View):RecyclerView.ViewHolder(itemView){
        val addressView:TextView=itemView.bankomat_address
        val statusView:TextView=itemView.bankomat_status
        val timeView:TextView=itemView.bankomat_time
    }

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): BankomatViewHolder {
       val itemView=LayoutInflater.from(parent.context).inflate(R.layout.bankomat_list,parent,false)
        return  BankomatViewHolder(itemView)
    }

    override fun onBindViewHolder(holder: BankomatViewHolder, position: Int) {
       val currentBankomat=bankomatList[position]
        holder.addressView.text=currentBankomat.city+" "+currentBankomat.address

        holder.timeView.text=currentBankomat.time_start.toString()+":00 - "+currentBankomat.time_end+":00"
            val sdf= SimpleDateFormat("HH")
            val hour=sdf.format(Date())
        if (hour.toInt()>currentBankomat.time_start && hour.toInt()<currentBankomat.time_end) {
            holder.statusView.setTextColor(Color.GREEN)
            holder.statusView.text = "Работает"
        }
        else {
            holder.statusView.setTextColor(Color.RED)
            holder.statusView.text = "Закрыто"
        }
        }

    override fun getItemCount()= bankomatList.size
}