package ru.loparev.session1

import androidx.appcompat.app.AppCompatActivity
import android.os.Bundle
import android.util.Log
import androidx.recyclerview.widget.LinearLayoutManager
import kotlinx.android.synthetic.main.activity_bankomats.*
import kotlinx.android.synthetic.main.activity_main.*
import retrofit2.Call
import retrofit2.Callback
import retrofit2.Response
import retrofit2.Retrofit
import retrofit2.converter.gson.GsonConverterFactory
import ru.loparev.session1.models.Bankomat
import ru.loparev.session1.models.Valuta

class BankomatsActivity : AppCompatActivity() {
    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_bankomats)

        val retrofit= Retrofit.Builder()
            .baseUrl("http://api.kansk-tc.ru")
            .addConverterFactory(GsonConverterFactory.create())
            .build()

        val getBankomatsAPI=retrofit.create(GetBankomatsAPI::class.java)

        val call: Call<List<Bankomat>> = getBankomatsAPI.bankomat

        call.enqueue(object : Callback<List<Bankomat>> {
            override fun onResponse(p0: Call<List<Bankomat>>, p1: Response<List<Bankomat>>) {
                val bankomat: List<Bankomat>? =p1.body()

                if (bankomat!=null){
                   listBankomates.adapter=BankomatAdapter(bankomat)
                    listBankomates.layoutManager=LinearLayoutManager(parent)
                }
            }

            override fun onFailure(p0: Call<List<Bankomat>>?, p1: Throwable?) {
                Log.d("TAG1",p0.toString())
            }
        })
    }
}