package ru.loparev.session1

import android.content.Context
import android.content.Intent
import android.os.Bundle
import android.util.Log
import android.view.LayoutInflater
import android.view.View
import android.widget.Button
import android.widget.EditText
import android.widget.Toast
import androidx.appcompat.app.AlertDialog
import androidx.appcompat.app.AppCompatActivity
import androidx.fragment.app.DialogFragment
import kotlinx.android.synthetic.main.activity_main.*
import retrofit2.Call
import retrofit2.Callback
import retrofit2.Response
import retrofit2.Retrofit
import retrofit2.converter.gson.GsonConverterFactory
import ru.loparev.session1.models.LoginModel
import ru.loparev.session1.models.LoginResponseTokenModel
import ru.loparev.session1.models.Notice
import ru.loparev.session1.models.Valuta
import java.text.SimpleDateFormat
import java.util.*


class MyDialogFragment : DialogFragment() {}
class MainActivity : AppCompatActivity() {
    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_main)
        dateNow.text=getCurrentDate()
//add Retrofit for get JSON
        val retrofit=Retrofit.Builder()
            .baseUrl("https://www.cbr-xml-daily.ru")
            .addConverterFactory(GsonConverterFactory.create())
            .build()
        val jsonPlaceHolderAPI=retrofit.create(JsonPlaceHolderAPI::class.java)
        val call:Call<Valuta> = jsonPlaceHolderAPI.course
        call.enqueue(object :Callback<Valuta>{
            override fun onResponse(p0: Call<Valuta>, p1: Response<Valuta>) {
                val course: Valuta =p1.body()
                if (course!=null){
                    USD_value.text= String.format("%.2f",course.Valute.USD.Value.toDouble())
                    EUR_value.text=String.format("%.2f",course.Valute.EUR.Value.toDouble())
                }
            }

            override fun onFailure(p0: Call<Valuta>?, p1: Throwable?) {

            }
        })
    }


    //    Function for get date
    fun getCurrentDate(): String {
    //val currentDate=Calendar.getInstance().time
    val sdf=SimpleDateFormat("dd.M.yyyy")
    val dateString=sdf.format(Date())
    return dateString
}

    fun clickEnter(view: View){
        val sharedPreference =  getSharedPreferences("TOKEN", Context.MODE_PRIVATE)
        val token=sharedPreference.getString("token","0").toString()
        Log.d("TAG1",token)
        val retrofit=Retrofit.Builder()
            .baseUrl("http://api.kansk-tc.ru")
            .addConverterFactory(GsonConverterFactory.create())
            .build()
        val posttokenAPI=retrofit.create(PostTokenAPI::class.java)
        val call=posttokenAPI?.postToken("Bearer "+token)
        call?.enqueue(object :Callback<Notice>{
            override fun onResponse(p0: Call<Notice>, p1: Response<Notice>) {
                val notice: Notice =p1.body()
                if (notice!=null){
                    Log.d("TAG1",notice.toString())
                    intent= Intent(this@MainActivity,MainActivity2::class.java)
                    startActivity(intent)
                }
            }

            override fun onFailure(p0: Call<Notice>?, p1: Throwable?) {
                Log.d("TAG1",p1.toString())
                clickEnterAuth(view)
            }
        })



        //Log.d("TAG1",sharedPreference.getString("token","0").toString())
    }
//Function for message box
    fun clickEnterAuth(view: View) {
        val li = LayoutInflater.from(this)
        val prompt: View = li.inflate(R.layout.enter, null)
        val alertDialog = AlertDialog.Builder(this)
        val buttonEnter: Button = prompt.findViewById(R.id.buttonEnter)
        val buttonCancel: Button = prompt.findViewById(R.id.buttonCancel)
        val login: EditText = prompt.findViewById(R.id.editTextTextPersonName)
        val password: EditText = prompt.findViewById(R.id.editTextTextPassword)
        alertDialog.setCancelable(true)
        alertDialog.setView(prompt)
        val dialog = alertDialog.create()
        buttonEnter.setOnClickListener({
            dialog.dismiss()
            enterPressed(login,password)})
        buttonCancel.setOnClickListener({
            dialog.dismiss()
            })
        dialog.show()
    }


    fun enterPressed(login: EditText, password: EditText) {
        val retrofit=Retrofit.Builder()
            .baseUrl("http://api.kansk-tc.ru")
            .addConverterFactory(GsonConverterFactory.create())
            .build()
        val TokenAPI=retrofit.create(GetTokenAPI::class.java)
        val call=TokenAPI?.login(LoginModel(login.text.toString(),password.text.toString(),"test"))
        call?.enqueue(object :Callback<LoginResponseTokenModel>{
            override fun onResponse(p0: Call<LoginResponseTokenModel>, p1: Response<LoginResponseTokenModel>) {

                //Сохраняем токен в настройках
                val sharedPreference =  getSharedPreferences("TOKEN", Context.MODE_PRIVATE)
                var token = sharedPreference.edit()
                token.putString("token",p1.body().token)
                token.commit()

                Log.d("TAG1",p1.body().token)
            }

            override fun onFailure(p0: Call<LoginResponseTokenModel>?, p1: Throwable?) {
                Log.d("TAG1",p0.toString())
            }
        })
//        Toast.makeText(this, login.text, Toast.LENGTH_SHORT).show()
    }

    fun clickBankomats(view: View) {
    intent= Intent(this,BankomatsActivity::class.java)
    startActivity(intent)

    }


}